package com.weaver.seconddev.interfaces.workflow.action;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.weaver.seconddev.interfaces.prop.ConfigProp;
import org.apache.commons.lang.StringUtils;
import com.weaver.seconddev.interfaces.eipoa.PortalPlanService ;
import com.weaver.seconddev.interfaces.eipoa.SI_HTPortalPlan_OUTServiceStub.InsertPlan;
import com.weaver.seconddev.interfaces.swfa.BillFieldUtil;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import org.springframework.core.env.Environment;
import java.lang.*;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.hrm.company.SubCompanyComInfo;
import com.weaver.verupgrade.hrm.resource.ResourceComInfo;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.interfaces.workflow.action.Action;

@org.springframework.stereotype.Service("workflow_action_AccommodationAction")
public class AccommodationAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {

    @Autowired
    private ConfigProp configProp;
    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_ee887589 = LoggerFactory.getLogger(AccommodationAction.class);

    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo requestinfo = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        try {
            String requestid = requestinfo.getRequestid();
            String workflowid = requestinfo.getWorkflowid();
            try {
                logger_ee887589.info(String.valueOf(requestid + "-AccommodationAction-start"));
                Map<String, String> map = new HashMap<String, String>();
                Property[] properties = requestinfo.getMainTableInfo().getProperty();
                for (int i = 0; i < properties.length; i++) {
                    String name = properties[i].getName().toUpperCase();
                    String value = Util.null2String(properties[i].getValue());
                    map.put(name, value);
                }
                BillFieldUtil util = new BillFieldUtil();
                SubCompanyComInfo com = I18nContextUtil.getBean(SubCompanyComInfo.class);
                ResourceComInfo res = I18nContextUtil.getBean(ResourceComInfo.class);
                String sqr = map.get("SQR");
                String ptry = map.get("PTRY");
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                String itemId = "SYS006" + util.getWorkcode(sqr) + sdf.parse(map.get("SQRQ") + " 08:00:00").getTime() + requestid;
                // 测试环境-101，正式环境-41
                String type = "41";
//                String url = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.pc_url")).trim();
                String url = configProp.getPc_url();
                String startDate = map.get("JDRQ") + " 00:00:00";
                String endDate = map.get("JDRQ") + " 23:59:59";
                String fromName = util.getName(sqr);
                RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
                StringBuilder content = new StringBuilder();
                String jcdd = "";
                String ptryxm = res.getLastnames(ptry);
                if ("0".equals(map.get("SFXDSJZXPT"))) {
                    ptryxm = res.getLastnames(map.get("PTRY1")) + "," + ptryxm;
                }
                // 测试环境-"59573",正式环境-Util.null2String(this.getPropValue("htportaloaUrl", "JCZS_ycsdid")).trim()
//                String title = com.getSubCompanyname(map.get("SQDW")) + "，" + map.get("ZRS") + "人，" + ptryxm + "，" + util.getselectName(map.get("YCSD"), Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.JCZS_ycsdid")).trim()).trim();
                String title = com.getSubCompanyname(map.get("SQDW")) + "，" + map.get("ZRS") + "人，" + ptryxm + "，" + configProp.getJCZS_ycsdid();
                if (!"1".equals(map.get("JDLB"))) {
                    content.append("就餐地点：");
                    if ("0".equals(map.get("DYJCCS"))) {
                        if ("0".equals(map.get("JDQY"))) {
                            jcdd = "吴江园区接待餐厅";
                        } else if ("1".equals(map.get("JDQY"))) {
                            jcdd = "亨通凯莱";
                        } else if ("2".equals(map.get("JDQY"))) {
                            jcdd = "常熟园区接待餐厅";
                        }
                    } else {
                        String poolname = CONN_TYPE.workflow.getType();
                        // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                        rs.executeSql("select jdmc from formtable_main_211 where id=" + map.get("JCCS"), poolname);
                        if (rs.next()) {
                            jcdd = rs.getString("jdmc");
                        }
                    }
                    content.append(jcdd);
                    if ("0".equals(map.get("YCSD"))) {
                        content.append("，午餐" + map.get("WUCRS") + "人；");
                        startDate = map.get("JDRQ") + " 11:30:00";
                        endDate = map.get("JDRQ") + " 13:30:59";
                    } else if ("1".equals(map.get("YCSD"))) {
                        content.append("，晚餐：" + map.get("WANCRS") + "人；");
                        startDate = map.get("JDRQ") + " 17:30:00";
                        endDate = map.get("JDRQ") + " 21:00:59";
                    } else {
                        content.append("，午餐：" + map.get("WUCRS") + "人，晚餐：" + map.get("WANCRS") + "人；");
                        startDate = map.get("JDRQ") + " 11:30:00";
                        endDate = map.get("JDRQ") + " 21:00:59";
                    }
                    // getPropValue("htportaloaUrl","JCZS_jdbzid")
                    // 接待等级
//                    title = title + "，" + util.getselectName(map.get("JDBZ"), I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.JCZS_jdbzid")).substring(0, 1);
                    title = title + "，" + util.getselectName(map.get("JDBZ"),configProp.getJCZS_jdbzid() ).substring(0, 1);
                }
                // 包厢号
                String jcbx = map.get("JCBX");
                if (jcbx != null && !jcbx.equals("")) {
                    title = title + "，" + jcbx;
                }
                String pc_url = "/workflow/request/ViewRequest.jsp?requestid=" + requestid + "&_workflowid=" + workflowid + "&_workflowtype=&isovertime=0";
                String mobile_url = "/mobile/plugin/1/view.jsp?requestid=" + requestid + "&_workflowid=" + workflowid + "&_workflowtype=&isovertime=0";
                String otherids = "";
                if ("0".equals(map.get("JDQY"))) {
//                    otherids = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.JCZS_WJYQTZR")).trim();
                    otherids = configProp.getJCZS_WJYQTZR();
                } else if ("1".equals(map.get("JDQY"))) {
//                    otherids = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.JCZS_QDYQTZR")).trim();
                    otherids = configProp.getJCZS_QDYQTZR();
                } else if ("2".equals(map.get("JDQY"))) {
//                    otherids = Util.null2String(I18nContextUtil.getBean(Environment.class).getProperty("htportaloaUrl.JCZS_CSYQTZR")).trim();
                    otherids =configProp.getJCZS_CSYQTZR();
                }
                String userid = "";
                if (!"".equals(otherids)) {
                    userid = getWorkcode(sqr + "," + ptry + "," + otherids, util);
                } else {
                    userid = getWorkcode(sqr + "," + ptry, util);
                }
                Map<String, String> info = new HashMap<String, String>();
                info.put("systemId", "SYS006");
                info.put("password", "123456");
                info.put("itemId", itemId);
                info.put("userId", userid);
                info.put("title", title);
                info.put("url", url + URLEncoder.encode(pc_url));
                info.put("type", type);
                info.put("startDate", startDate);
                info.put("endDate", endDate);
                info.put("status", "0");
                info.put("priority", "0");
                info.put("formName", fromName);
                info.put("mobileUrl", url + URLEncoder.encode(mobile_url));
                info.put("category", "就餐住宿");
                info.put("source", "1");
                info.put("content", content.toString());
                PortalPlanService service = new PortalPlanService();
                InsertPlan insertData = JSONObject.parseObject(JSON.toJSONString(info), InsertPlan.class);
                String[] str = service.insertPlan(insertData);
                logger_ee887589.info(requestid + "-AccommodationAction-传值[" + JSON.toJSONString(info) + "]");
                logger_ee887589.info(String.valueOf(requestid + "-AccommodationAction-end-返回值：[" + str[0] + "-" + str[1] + "]"));
            } catch (Exception e) {
                logger_ee887589.info(String.valueOf(requestid + "-AccommodationAction-error:" + e.toString()));
            }
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, requestinfo.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_ee887589.error("AccommodationAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), requestinfo.getRequestManager())), requestinfo.getRequestManager()));
        }
    }

    public String getWorkcode(String ids, BillFieldUtil util) {
        String[] arr = ids.split(",");
        HashSet<String> set = new HashSet<String>();
        for (int i = 0; i < arr.length; i++) {
            if (!"".equals(arr[i])) {
                set.add(util.getWorkcode(arr[i]));
            }
        }
        return StringUtils.join(set.toArray(), ";");
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
