package com.weaver.seconddev.interfaces.workflow.action;

import com.alibaba.fastjson.JSON;
import com.weaver.common.base.entity.result.WeaResult;
import com.weaver.common.hrm.util.HrmContextUtil;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.custom.configcenter.htsysjcmtConfig;
import com.weaver.ebuilder.form.client.ebform.data.EbFormDataDubboService;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.framework.client.annotation.WeaverConfigCenter;
import com.weaver.framework.rpc.annotation.RpcReference;
import com.weaver.seconddev.interfaces.workflow.action.prop.TestProp;
import com.weaver.seconddev.interfaces.workflow.util.CommonDevUtil;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.verupgrade.conn.CONN_TYPE;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.general.BaseBean;
import com.weaver.verupgrade.interfaces.workflow.action.Action;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import com.weaver.verupgrade.workflow.request.RequestManager;
import lombok.Data;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service("workflow_action_CustomTeAction")
public class CustomTeAction extends BaseBean implements Action, EsbServerlessRpcRemoteInterface {


    @Autowired
    private RequestInfo requestInfoTemp;

    @Autowired
    private CommonDevUtil commonDevUtil;
    @Autowired
    private TestProp testProp;

    @RpcReference(group = "ebuilderform")
    private EbFormDataDubboService ebFormDataDubboService;

    @Value("${weaver.swagger.basePackage}")
    private String basePackage;
    private static final org.slf4j.Logger logger = LoggerFactory.getLogger(CustomTeAction.class);


    @Override
    public WeaResult<Map<String, Object>> execute(Map<String, Object> params) {
        logger.error("start CustomTeAction");
        logger.error("srmbacklisturl == " + testProp.getSrmbacklisturl());
        logger.error("basePackage == " + basePackage);
        logger.error("params = " + JSON.toJSONString(params));

        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(params.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(params.getOrDefault("userid", -1)));
        RequestInfo request = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);

        try{
            List list = new ArrayList<String>();
            list.get(2);


//        logger.info("requestIdTemp = " + requestIdTemp);
//        logger.info("userIdTemp = " + userIdTemp);
//
//
        SimpleEmployee currentEmployee = HrmContextUtil.getCurrentUser();

        String tenantKey = HrmContextUtil.getCurrentTenantKey();
        logger.info("tenantKey = " + tenantKey);
//
//
        RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
//        String sql1 = "select *  from  e10_common.dbo.uf_CustomFlow  where field1  = 1 and delete_type = 0 ";
        String poolname = CONN_TYPE.ebuilder.getType();
//        rs.setTenantKey(tenantKey);
//        rs.executeSql(sql1, poolname);
//        rs.next();
//        String field1 = rs.getString("field1");
//
//
//        String sql2 = "update  e10_common.dbo.uf_CustomFlow  set field2 = '修改后数据' where field1  = 2 and delete_type = 0 ";
//        boolean b = rs.executeSql(sql2, poolname);
//        logger.info("更新 = " + b);
//
//
//        //rpc新增建模数据
        Long uf_CustomFlow_formId = commonDevUtil.getObjId("uf_CustomFlow");
        logger.info("uf_CustomFlow_formId = " + uf_CustomFlow_formId);
        Long recodId = ebFormDataDubboService.addEmptyData(uf_CustomFlow_formId, currentEmployee);// 获取插入的空的建模id
        String sql3 = "update  e10_common.dbo.uf_CustomFlow  set field2 = '添加数据' where id  =  " + recodId + " and delete_type = 0 ";
        boolean b1 = rs.executeSql(sql3, poolname);
        logger.info("sql3 = " + sql3);
        logger.info("添加 = " + b1);

        logger.error("stop CustomTeAction");
        Map<String, Object> res = new HashMap<>();
        res.put("status", true);
        res.put("msg", "success");
        res.put("params", params);
            return WeaResult.success(res);
        }catch (Exception e){
            return  WeaResult.fail(500, "出错啦", getResultMapForAction(weaverResultMap, "result", e.getMessage(), request.getRequestManager()));
        }

//
    }
    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {

        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }



}
